#!/usr/bin/python
"""Creates a background for the brochure for the 
European Python and Zope Conference 2003.
(This template will then be pagecaught and used elsewhere)
"""

def run():
    from reportlab.pdfgen import canvas
    from reportlab.lib.pagesizes import A4
    from reportlab.lib.units import inch, cm
    from rlextra.pageCatcher.pageCatcher import restoreForms

    c = canvas.Canvas("brochure_template.pdf", pagesize=A4)
    width, height = A4 #may need later...
    x = inch
    y = 0.35*inch
    c.setFont("Helvetica-Oblique", 10)
    line = "European Python and Zope Conference 2003"
    c.drawRightString(A4[0]-x, y+20, line)
    ff = 7.5 # fudge factor - compensating for some pageCatcher wierdness
    c.line(inch+ff, (0.8*inch)+20, A4[0]-inch+ff, (0.8*inch)+20)
    c.line(inch+ff, A4[1]-(0.8*inch), A4[0]-inch+ff, A4[1]-(0.8*inch))
    c.saveState()
    restoreForms('ep_logo_alternative_1.data', c, verbose=1)
        #c.rotate(90)
    sf = 0.075 #scalefactor
    xtrans = 0.85*inch
    ytrans = (0.75*inch)+20
    c.translate(xtrans,ytrans)
    c.rotate(-90)
    c.scale(sf, sf)
    c.doForm('cover_PF0')
    c.restoreState()
    c.showPage()

    c.save()

if __name__ == '__main__':
    run() #simple!
