#!/usr/home/rptlab2/bin/python -u
import os, sys, string, traceback, cgi, time, xmlrpclib
from types import StringType
from rlextra.utils import cgihelp

HTTP_PDFOUT='/pdfout'
PDFOUT='../../pdfout'
form=None
class cgidata:
	def __init__(self):
		self._form = cgi.FieldStorage()
		self._D = {}
		self._setDefaults(
			pdfPS='A4',
			TTSize='A4',
			)

	def makeURLArgs(self):
		s = []
		for k, v in self._D.items():
			s.append('%s=%s'%(k,v))
		return string.join(s,'&')

	def has_key(self,k):
		return self._form.has_key(k)

	def __getitem__(self,k):
		try:
			return self._D[k]
		except KeyError:
			return self._form[k].value

	def _setDefaults(self,**kw):
		form, D = self._form, self._D
		for k, v in kw.items():
			if form.has_key(k):
				s = form[k].value
				if type(v) is StringType or isNumber(s):
					v = s
			D[k] = v

FORM='''
<table>
<tr><td align=left>Generated by (optional)</td>
	<td align=left>Generated for (optional)</td>
	</tr>
<tr><td align=left><input type=text name=genBy value="" size=20 maxsize=256></td>
	<td align=left><input type=text name=genFor value="" size=20 maxsize=256></td>
	</tr>
%(checks)s
<tr><td colspan=2>&nbsp;</td>
	</tr>
<tr><td align=left><input type=submit name=action value="Get PDF"></td>
	<td align=left>%(select_pdfPS)s</td>
	</tr>
</table>'''


#'''
#<tr><td colspan=2><hr width="80%%"></td></tr>
#<tr><td colspan=2 align=center>Get Time Table</td></tr>
#<tr><td>%(select_TTSize)s</td><td><input type=submit name=action value="Get Timetable"></td></tr>
#</table>
#'''

Blurb='''
ReportLab have built the brochure for the EuroPython Conference again this year.  This
is a dynamic document which pulls information from a Zope database of talks,
allowing everything to be regenerated in a few seconds if timetables change.
To build your own brochure, and add your name to the
cover simply select the details you want to appear and click
'Get PDF'.
<hr>
'''
def getServer():
	import xmlrpclib
	return xmlrpclib.ServerProxy('http://server.reportlab.com/cgi-bin/xmlrpc_epc_brochure2003.cgi')

def doPDF():
	server = getServer()
	formnames = server.formNames('17gnarls')
	T, I = formnames['tracks'], formnames['interviews']
	tracks, interviews = [], []
	genBy = form.has_key('genBy') and form['genBy'] or ''
	genFor = form.has_key('genFor') and form['genFor'] or ''
	for l,d in (tracks,T), (interviews,I):
		for k in d.keys():
			if form.has_key(k): l.append(k)
	#pdfPS = form['pdfPS']
	R = server.makeBrochure('17gnarls',tracks,interviews,genBy,genFor)
	filename, filesize = R['filename'], R['filesize']
	return cgihelp.writeResultPage('http://server.reportlab.com'+filename,
			'http://server.reportlab.com/cgi-bin/epc_brochure2003.cgi',
			title = 'ReportLab EPC Brochure Generation Demo',
			heading = 'ReportLab EPC Brochure Generation Demo',
			body = '',
			docname='EPC Brochure',
			filesize=filesize)

def doTT():
	server = getServer()
	formnames = server.formNames('17gnarls')
	pagesize = form.has_key('TTSize') and form['TTSize'] or 'A4'
	R = server.makeTimetable('17gnarls',pagesize)
	filename, filesize = R['filename'], R['filesize']
	return cgihelp.writeResultPage('http://server.reportlab.com'+filename,
			'http://server.reportlab.com/cgi-bin/epc_brochure2003.cgi',
			title = 'ReportLab EPC Brochure Generation Demo',
			heading = 'ReportLab EPC Brochure Generation Demo',
			body = '',
			docname='EPC Timetable',
			filesize=filesize)

def doHTML():
	formnames = getServer().formNames('17gnarls')
	T, I = formnames['tracks'], formnames['interviews']
	TK, IK = T.keys(), I.keys()
	TK.sort()
	IK.sort()
	nT, nI = len(T),len(I)
	n = max(nT,nI)
	checks = ''
	for i in xrange(n):
		vT = i<nT and '<input type="checkbox" name="%s" value="1" checked> %s' % (TK[i],T[TK[i]]) or ''
		vI = i<nI and '<input type="checkbox" name="%s" value="1" checked> %s' % (IK[i],I[IK[i]]) or ''
		checks += '<tr><td align=left>%s</td>\n\t<td align=left>%s</td>\n\t</tr>\n' % (vT, vI)
	if checks:
		checks = '<tr><td colspan=2>&nbsp;</td>\n\t</tr>\n<tr><td align=left>Select Tracks Below</td>\n\t<td align=left>Select Interviews Below</td>\n\t</tr>\n' + checks

	select_pdfPS = 'PDF Page Size: '+cgihelp.makeHTMLSelect('pdfPS',('A4','letter'),form['pdfPS'])
	select_pdfPS = ''
	select_TTSize= 'Select TimeTable Size: '+cgihelp.makeHTMLSelect('TTSize',('A0','A1','A2','A3','A4','letter'),form['TTSize'])
	return cgihelp.writeQueryPage('http://server.reportlab.com/cgi-bin/epc_brochure2003.cgi',
					title = 'ReportLab EPC Brochure Generation Demo',
					heading = 'ReportLab EPC Brochure Generation Demo',
					body=Blurb,
					preform='<p><center>Select your options and press the button below to make the PDF.</center></p>',
					form = FORM % locals() )

def run(http_pdfout='/pdfout',pdfout='../../pdfout'):
	global form,HTTP_PDFOUT,PDFOUT
	HTTPD_PDFOUT=http_pdfout
	PDFOUT=pdfout
	form = cgidata()
	sys.stderr = sys.stdout
	try:
		if form.has_key('action') and form['action']=='Get PDF':
			s = doPDF()
		elif form.has_key('action') and form['action']=='Get Timetable':
			s = doTT()
		else:
			s = doHTML()
		print "Content-type: text/html"
		print
		print s
	except:
		print "Content-type: text/html"
		print
		print '<html><head></head><body text=#ff0000><pre>'
		traceback.print_exc()
		print '</pre></body></html>'

if __name__ == '__main__':
	run()
